import App

def CreateAI(pShip):
	#########################################
	# Creating CompoundAI ChickenKiller at (141, 32)
	import AI.Compound.BasicAttack
	pChickenKiller = AI.Compound.BasicAttack.CreateAI(pShip, "Chicken 1")
	# Done creating CompoundAI ChickenKiller
	#########################################
	#########################################
	# Creating ConditionalAI RangeConditional at (134, 97)
	## Conditions:
	#### Condition IsChickenInRange
	pIsChickenInRange = App.ConditionScript_Create("Conditions.ConditionInRange", "ConditionInRange", 240, "Chicken")
	## Evaluation function:
	def EvalFunc(bIsChickenInRange):
		ACTIVE = App.ArtificialIntelligence.US_ACTIVE
		DORMANT = App.ArtificialIntelligence.US_DORMANT
		DONE = App.ArtificialIntelligence.US_DONE
		if(bIsChickenInRange):
			return ACTIVE
		return DORMANT
	## The ConditionalAI:
	pRangeConditional = App.ConditionalAI_Create(pShip, "RangeConditional")
	pRangeConditional.SetInterruptable(1)
	pRangeConditional.SetContainedAI(pChickenKiller)
	pRangeConditional.AddCondition(pIsChickenInRange)
	pRangeConditional.SetEvaluationFunction(EvalFunc)
	# Done creating ConditionalAI RangeConditional
	#########################################
	#########################################
	# Creating CompoundAI ChickenKiller_2 at (290, 37)
	import AI.Compound.BasicAttack
	pChickenKiller_2 = AI.Compound.BasicAttack.CreateAI(pShip, "Chicken 2")
	# Done creating CompoundAI ChickenKiller_2
	#########################################
	#########################################
	# Creating PriorityListAI TargetPriority at (114, 166)
	pTargetPriority = App.PriorityListAI_Create(pShip, "TargetPriority")
	pTargetPriority.SetInterruptable(1)
	# SeqBlock is at (220, 148)
	pTargetPriority.AddAI(pRangeConditional, 1)
	pTargetPriority.AddAI(pChickenKiller_2, 2)
	# Done creating PriorityListAI TargetPriority
	#########################################
	#########################################
	# Creating PreprocessingAI AvoidObstacles at (140, 238)
	## Setup:
	import AI.Preprocessors
	pScript = AI.Preprocessors.AvoidObstacles()
	## The PreprocessingAI:
	pAvoidObstacles = App.PreprocessingAI_Create(pShip, "AvoidObstacles")
	pAvoidObstacles.SetInterruptable(1)
	pAvoidObstacles.SetPreprocessingMethod(pScript, "Update")
	pAvoidObstacles.SetContainedAI(pTargetPriority)
	# Done creating PreprocessingAI AvoidObstacles
	#########################################
	return pAvoidObstacles
