import App

def Initialize():
	# Create the set ("Cebalrai1")
	pSet = App.SetClass_Create()
	App.g_kSetManager.AddSet(pSet, "Cebalrai1")

	# Save the name of the region file that's creating the set.
	pSet.SetRegionModule("Systems.Cebalrai.Cebalrai1")

	# Activate the proximity manager for our set.
	pSet.SetProximityManagerActive(1)


	# Load the placements and backdrops for this set.
	LoadPlacements("Cebalrai1")
	LoadBackdrops(pSet)

	#Load and place the grid.
	pGrid = App.GridClass_Create()
	pSet.AddObjectToSet(pGrid, "grid")
	pGrid.SetHidden(1)

	# Create static objects for this set:
	# If you want to create static objects for this region, make a
	# "Cebalrai1_S.py" file with an Initialize function that creates them.
	try:
		import Cebalrai1_S
		Cebalrai1_S.Initialize(pSet)
	except ImportError:
		# Couldn't find the file.  That's ok.  Do nothing...
		pass

	# Done.

def GetSetName():
	return "Cebalrai1"

def GetSet():
	return App.g_kSetManager.GetSet("Cebalrai1")

def Terminate():
	App.g_kSetManager.DeleteSet("Cebalrai1")

def LoadPlacements(sSetName):
	# Position "Asteroid1"
	kThis = App.Waypoint_Create("Asteroid1", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(137.088715, -91.920853, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.962898, 0.041124, -0.266713)
	kUp = App.TGPoint3()
	kUp.SetXYZ(-0.204612, 0.755659, -0.622184)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Asteroid1"

	# Position "Asteroid2"
	kThis = App.Waypoint_Create("Asteroid2", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(75.731674, -47.977818, -129.130981)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.681938, -0.194471, -0.705083)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.637134, 0.631368, 0.442080)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Asteroid2"

	# Position "Asteroid4"
	kThis = App.Waypoint_Create("Asteroid4", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(-101.569168, -305.969666, 93.279533)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.099048, 0.994901, -0.019014)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.875004, -0.077980, 0.477794)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Asteroid4"

	# Position "Asteroid3"
	kThis = App.Waypoint_Create("Asteroid3", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(-80.079720, -283.618164, -48.233040)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.000000, 1.000000, 0.000000)
	kUp = App.TGPoint3()
	kUp.SetXYZ(-0.719594, 0.000000, -0.694395)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Asteroid3"

	# Light position "Ambient Light"
	kThis = App.LightPlacement_Create("Ambient Light", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.000000, 1.000000, 0.000000)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.000000, 0.000000, 1.000000)
	kThis.AlignToVectors(kForward, kUp)
	kThis.ConfigAmbientLight(1.000000, 1.000000, 1.000000, 0.1)
	kThis.Update(0)
	kThis = None
	# End position "Ambient Light"

	# Light position "Directional Light"
	kThis = App.LightPlacement_Create("Directional Light", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.000000, -1.000000, 0.000000)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.000000, 0.000000, 1.000000)
	kThis.AlignToVectors(kForward, kUp)
	kThis.ConfigDirectionalLight(1, .5, .5, .9)
	kThis.Update(0)
	kThis = None
	# End position "Directional Light"

	# Position "Sun"
	kThis = App.Waypoint_Create("Sun", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(0.0, 70000.0, 0.0)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.000000, 1.000000, 0.000000)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.000000, 0.000000, 1.000000)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Sun"

	# Position "Player Start"
	kThis = App.Waypoint_Create("Player Start", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.000000, 1.000000, 0.000000)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.000000, 0.000000, 1.000000)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Player Start"

	# Position "Planet Location"
	kThis = App.Waypoint_Create("Planet Location", sSetName, None)
	kThis.SetStatic(1)
	kThis.SetTranslateXYZ(1000.000000, 1500.000000, -500.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.332255, -0.942401, -0.038562)
	kUp = App.TGPoint3()
	kUp.SetXYZ(-0.002558, -0.041785, 0.999123)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetSpeed(25.000000)
	kThis.Update(0)
	kThis = None
	# End position "Planet Location"

import App

def LoadBackdrops(pSet):

	#Draw order is implicit. First object gets drawn first

	# Star Sphere "Backdrop stars"
	kThis = App.StarSphere_Create()
	kThis.SetName("Backdrop stars")
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.185766, 0.947862, -0.258937)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.049811, 0.254101, 0.965894)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetTextureFileName("data/stars.tga")
	kThis.SetTargetPolyCount(256)
	kThis.SetHorizontalSpan(1.000000)
	kThis.SetVerticalSpan(1.000000)
	kThis.SetSphereRadius(300.000000)
	kThis.SetTextureHTile(22.000000)
	kThis.SetTextureVTile(11.000000)
	kThis.Rebuild()
	pSet.AddBackdropToSet(kThis,"Backdrop stars")
	kThis.Update(0)
	kThis = None
	# End Backdrop Sphere "Backdrop stars"

	# Backdrop Sphere "Backdrop treknebula6"
	kThis = App.BackdropSphere_Create()
	kThis.SetName("Backdrop treknebula6")
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(-0.920688, -0.225766, -0.318376)
	kUp = App.TGPoint3()
	kUp.SetXYZ(-0.309215, -0.075824, 0.947965)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetTextureFileName("data/Backgrounds/treknebula6.tga")
	kThis.SetTargetPolyCount(256)
	kThis.SetHorizontalSpan(0.041693)
	kThis.SetVerticalSpan(0.083386)
	kThis.SetSphereRadius(300.000000)
	kThis.SetTextureHTile(1.000000)
	kThis.SetTextureVTile(1.000000)
	kThis.Rebuild()
	pSet.AddBackdropToSet(kThis,"Backdrop treknebula6")
	kThis.Update(0)
	kThis = None
	# End Backdrop Sphere "Backdrop treknebula6"

	# Backdrop Sphere "Backdrop galaxy3 2"
	kThis = App.BackdropSphere_Create()
	kThis.SetName("Backdrop galaxy3 2")
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.502253, -0.837669, 0.214599)
	kUp = App.TGPoint3()
	kUp.SetXYZ(-0.110354, 0.184051, 0.976702)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetTextureFileName("data/Backgrounds/galaxy3.tga")
	kThis.SetTargetPolyCount(231)
	kThis.SetHorizontalSpan(0.033771)
	kThis.SetVerticalSpan(0.067543)
	kThis.SetSphereRadius(300.000000)
	kThis.SetTextureHTile(1.000000)
	kThis.SetTextureVTile(1.000000)
	kThis.Rebuild()
	pSet.AddBackdropToSet(kThis,"Backdrop galaxy3 2")
	kThis.Update(0)
	kThis = None
	# End Backdrop Sphere "Backdrop galaxy3 2"

	# Backdrop Sphere "Backdrop galaxy4"
	kThis = App.BackdropSphere_Create()
	kThis.SetName("Backdrop galaxy4")
	kThis.SetTranslateXYZ(0.000000, 0.000000, 0.000000)
	kForward = App.TGPoint3()
	kForward.SetXYZ(0.758749, -0.497946, -0.419939)
	kUp = App.TGPoint3()
	kUp.SetXYZ(0.351085, -0.230408, 0.907552)
	kThis.AlignToVectors(kForward, kUp)
	kThis.SetTextureFileName("data/Backgrounds/galaxy4.tga")
	kThis.SetTargetPolyCount(256)
	kThis.SetHorizontalSpan(0.030394)
	kThis.SetVerticalSpan(0.060788)
	kThis.SetSphereRadius(300.000000)
	kThis.SetTextureHTile(1.000000)
	kThis.SetTextureVTile(1.000000)
	kThis.Rebuild()
	pSet.AddBackdropToSet(kThis,"Backdrop galaxy4")
	kThis.Update(0)
	kThis = None
	# End Backdrop Sphere "Backdrop galaxy4"